normtdc<-function(tab.disj,data.na){
  #normalise le tdc
  tdc<-tab.disj
  tdc[tdc<0]<-0
  tdc[tdc>1]<-1
  col.suppr<-cumsum(sapply(data.na,function(x){nlevels(x)}))
  tdc<-t(apply(tdc,1,FUN=function(x,col.suppr){
    if(sum(x[1:col.suppr[1]])!=1){x[1:col.suppr[1]]<-x[1:col.suppr[1]]/sum(x[1:col.suppr[1]])}
    for (i in 2:length(col.suppr)){
      x[(col.suppr[i-1]+1):(col.suppr[i])]<-x[(col.suppr[i-1]+1):(col.suppr[i])]/sum(x[(col.suppr[i-1]+1):col.suppr[i]])
    }
    return(x)
  },col.suppr=col.suppr))
  return(tdc)
}

draw<-function(tabdisj,Don) {
  #tirage direct dans le tdc
  nbdummy <- rep(1, ncol(Don))
  is.quali <- which(!unlist(lapply(Don, is.numeric)))
  nbdummy[is.quali] <- unlist(lapply(Don[, is.quali, drop = FALSE], 
                                     nlevels))
  vec = c(0, cumsum(nbdummy))
  Donres <- Don
  for (i in is.quali) {
    Donres[, i] <- as.factor(levels(Don[, i])[
      apply(tabdisj[,(vec[i] + 1):vec[i + 1]]
            , 1, function(x){
              sample(1:length(x),size=1,prob=x)
            }
      )])
    Donres[, i]<-factor(Donres[, i],levels(Don[,is.quali][,i]))#ajouter pour conserver l'ordre des niveaux
  }
  if(sum(Don[!is.na(Don)]!=Donres[!is.na(Don)])>0){stop("error in function draw")}
  return(don.imp=Donres)
}

reconst.MCA<-function(tab.disj.comp,ncp,nbvar){
  moy.p <- function(V, poids) {
    res <- sum(V * poids, na.rm = TRUE)/sum(poids[!is.na(V)])
  }
  row.w<-rep(1/nrow(tab.disj.comp),nrow(tab.disj.comp))
  M <- apply(tab.disj.comp, 2, moy.p, row.w)/nbvar
  Z <- sweep(tab.disj.comp, 2, apply(tab.disj.comp, 2, moy.p, 
                                     row.w), FUN = "/")
  Z <- sweep(Z, 2, apply(Z, 2, moy.p, row.w), FUN = "-")
  Zscale <- sweep(Z, 2, sqrt(M), FUN = "*")
  svd.Zscale <- svd.triplet(Zscale, row.w = row.w)
  eig <- ((svd.Zscale$vs[1:ncp]^2)/svd.Zscale$vs[1:ncp])
  if (ncp == 1) 
    rec <- tcrossprod(svd.Zscale$U[, 1] * eig, 
                      svd.Zscale$V[, 1])
  else rec <- tcrossprod(sweep(svd.Zscale$U[, 1:ncp], 2, 
                               eig, FUN = "*"), svd.Zscale$V[, 1:ncp])
  tab.disj.rec <- sweep(rec, 2, sqrt(M), FUN = "/") + matrix(1, 
                                                             nrow(rec), ncol(rec))
  tab.disj.rec <- sweep(tab.disj.rec, 2, apply(tab.disj.comp, 
                                               2, moy.p, row.w), FUN = "*")
  return(tab.disj.rec)
}


myimputeMCA<-function (don, ncp = 2, method = c("Regularized", "EM"), row.w = NULL, 
          coeff.ridge = 1, threshold = 1e-06, seed = NULL, maxiter = 1000) 
{
  moy.p <- function(V, poids) {
    res <- sum(V * poids, na.rm = TRUE)/sum(poids[!is.na(V)])
  }
  find.category <- function(X, tabdisj) {
    nbdummy <- rep(1, ncol(X))
    is.quali <- which(!unlist(lapply(X, is.numeric)))
    nbdummy[is.quali] <- unlist(lapply(X[, is.quali, drop = FALSE], 
                                       nlevels))
    vec = c(0, cumsum(nbdummy))
    Xres <- X
    for (i in is.quali) {
      temp <- as.factor(levels(X[, i])[apply(tabdisj[,
                                                     (vec[i] + 1):vec[i + 1]], 1, which.max)])
      Xres[,i]<-factor(temp,levels(X[,is.quali][,i]))
    }
    return(Xres)
  }
  tab.disjonctif.NA <- function(tab) {
    tab <- as.data.frame(tab)
    modalite.disjonctif <- function(i) {
      moda <- tab[, i]
      nom <- names(tab)[i]
      n <- length(moda)
      moda <- as.factor(moda)
      x <- matrix(0, n, length(levels(moda)))
      ind <- (1:n) + n * (unclass(moda) - 1)
      indNA <- which(is.na(ind))
      x[(1:n) + n * (unclass(moda) - 1)] <- 1
      x[indNA, ] <- NA
      if ((ncol(tab) != 1) & (levels(moda)[1] %in% c(1:nlevels(moda), 
                                                     "n", "N", "y", "Y"))) 
        dimnames(x) <- list(row.names(tab), paste(nom, 
                                                  levels(moda), sep = "."))
      else dimnames(x) <- list(row.names(tab), levels(moda))
      return(x)
    }
    if (ncol(tab) == 1) 
      res <- modalite.disjonctif(1)
    else {
      res <- lapply(1:ncol(tab), modalite.disjonctif)
      res <- as.matrix(data.frame(res, check.names = FALSE))
    }
    return(res)
  }
  cat("imputation...")
  method <- match.arg(method, c("Regularized", "regularized", 
                                "EM", "em"), several.ok = T)[1]
  method = tolower(method)
  if (is.null(row.w)) 
    row.w = rep(1/nrow(don), nrow(don))
  if (ncp == 0) 
    return(list(tab.disj = tab.disjonctif.prop(don, NULL, 
                                               row.w = row.w), completeObs = find.category(don, 
                                                                                           tab.disjonctif.prop(don, NULL, row.w = row.w))))
  tab.disj.NA = tab.disjonctif.NA(don)
  hidden = which(is.na(tab.disj.NA))
  tab.disj.comp = tab.disjonctif.prop(don, seed, row.w = row.w)
  tab.disj.rec.old = tab.disj.comp
  continue = TRUE
  nbiter = 0
  while (continue) {
    nbiter = nbiter + 1
    M = apply(tab.disj.comp, 2, moy.p, row.w)/ncol(don)
    if (any(M < 0)) 
      stop(paste("The algorithm fails to converge. Choose a number of components (ncp) less or equal than ", 
                 ncp - 1, " or a number of iteratsions (maxiter) less or equal than ", 
                 maxiter - 1, sep = ""))
    Z = sweep(tab.disj.comp, 2, apply(tab.disj.comp, 2, moy.p, 
                                      row.w), FUN = "/")
    Z = sweep(Z, 2, apply(Z, 2, moy.p, row.w), FUN = "-")
    Zscale = sweep(Z, 2, sqrt(M), FUN = "*")
    svd.Zscale = svd.triplet(Zscale, row.w = row.w)
    moyeig = 0
    if (nrow(don) > (ncol(Zscale) - ncol(don))) 
      moyeig = mean(svd.Zscale$vs[-c(1:ncp, (ncol(Zscale) - 
                                               ncol(don) + 1):ncol(Zscale))]^2)
    else moyeig = mean(svd.Zscale$vs[-c(1:ncp)]^2)
    moyeig = min(moyeig * coeff.ridge, svd.Zscale$vs[ncp + 
                                                       1]^2)
    if (method == "em") 
      moyeig <- 0
    eig.shrunk = ((svd.Zscale$vs[1:ncp]^2 - moyeig)/svd.Zscale$vs[1:ncp])
    if (ncp == 1) 
      rec = tcrossprod(svd.Zscale$U[, 1] * eig.shrunk, 
                       svd.Zscale$V[, 1])
    else rec = tcrossprod(sweep(svd.Zscale$U[, 1:ncp], 2, 
                                eig.shrunk, FUN = "*"), svd.Zscale$V[, 1:ncp])
    tab.disj.rec = sweep(rec, 2, sqrt(M), FUN = "/") + matrix(1, 
                                                              nrow(rec), ncol(rec))
    tab.disj.rec = sweep(tab.disj.rec, 2, apply(tab.disj.comp, 
                                                2, moy.p, row.w), FUN = "*")
    diff <- tab.disj.rec - tab.disj.rec.old
    diff[hidden] <- 0
    relch <- sum(sweep(diff^2, 1, row.w, FUN = "*"))
    tab.disj.rec.old = tab.disj.rec
    tab.disj.comp[hidden] = tab.disj.rec[hidden]
    continue = (relch > threshold) & (nbiter < maxiter)
  }
  tab = find.category(don, tab.disj.comp)
  ##
  cat("ok\n")
  return(list(tab.disj = tab.disj.comp, completeObs = tab))
}

MIMCA<-function(X.na,m,ncp,coeff.ridge=1){
  temp<-if(coeff.ridge==1){"regularized"}else if(coeff.ridge==0){"EM"}else{paste("coeff.ridge=",coeff.ridge)}
  cat("Multiple Imputation using",temp,"MCA using m =",m,"imputed arrays","\n")
  n<-nrow(X.na)
  Boot<-matrix(sample(1:n,size=m*n,replace=T),n,m)
  Weight<-matrix(1/(n*1000),n,m,dimnames=list(1:n,paste("m=",1:m,sep="")))
  Boot.table<-apply(Boot,2,table)
  for(i in 1:m){
    Weight[names(Boot.table[[i]]),i]<-Boot.table[[i]]
  }
  Weight<-sweep(Weight,2,FUN="/",STAT=colSums(Weight))
  res.imp<-apply(Weight,2,myimputeMCA,don=X.na,ncp=ncp,coeff.ridge= coeff.ridge,method="Regularized")
  tdc.imp<-lapply(res.imp,"[[","tab.disj")
  tdc.norm<-lapply(tdc.imp,FUN=normtdc,data.na=X.na)
  X.imp<-lapply(tdc.norm,FUN=draw,Don=X.na)
  res<-list(X.imp=X.imp,tdc.imp=tdc.imp,Ind=Boot,Weight=Weight)
  class(res)<-"MIMCA.w"
  return(res)
}