rm(list=ls())
gc()

setwd("")
path.save<-""
set.seed(1234)
graphics.off()

#install.packages("copula")
#install.packages("mvtnorm");install.packages("missForest");install.packages("missMDA");install.packages("cat");install.packages("Amelia");install.packages("mice");install.packages("Matrix")
#source("http://www.columbia.edu/~bg2382/mi/install_mi.R", echo = TRUE)

library(mvtnorm)
library(missForest)
library(missMDA)
library(cat)
library(Amelia)
library(mice)
library(mi)
library(Matrix)
library(copula)
library(nnet)
library(binom)

load("Sbp.Rdata")
load("Saheart.Rdata")
load("galetas.Rdata")
load("income.Rdata")
load("Titanic.Rdata")
load("credit.Rdata")

Jeux<-list(SAheart=Saheart,galetas=galetas,sbp=Sbp,income=income,Titanic=Titanic,credit=credit)

source("parameters.r")
source("MIMCA.r",encoding="latin1")
source("functions_simulation.r",encoding="latin1")


#_________________________quality of the inference______________________________
if(FALSE){
  for(i in names(Jeux)){
    temp<-Simulate.real(X=Xsimu[[i]],Y=Ysimu[[i]],
                        nsim=Nsim[[i]],S=S[[i]],verbose=F,
                        path.save=path.save,coeff.ridge=1,formula.multinom=Formula.multinom[[i]],
                        n.ech=N.ech[[i]],var.interest=var.interest[[i]],methods=Method[[i]],plot.sum=T,
                        theta=Theta[[i]],Name=i)
    save(temp,file=paste(path.save,"result_",i,".Rdata",sep=""))
  }
}

#________________time consummed to impute 5 times a real dataset______________
if(FALSE){
  res.time<-array(NA,c(6,length(Jeux),5),dimnames=list(c("Loglinear","DPMPM","Normal","MIMCA","FCS-log","FCS-rf"),names(Jeux),names(system.time(a<-1))))  
  m<-5
  for (j in names(Jeux)){
    print(j)
    X<-Jeux[[j]]
    Xna<-prodNA(X,0.2)
    
    #MIMCA
    if("MIMCA.w" %in%Method[[j]]){
      res.time[4,j,]<-system.time(x.imp<-MIMCA(X.na=Xna,m=m,ncp=S[[j]],coeff.ridge=1))
    }
    
    #Normal
    if("amelia" %in%Method[[j]]){
      res.time[3,j,]<-system.time(x.imp<-amelia(x=Xna,m=m,p2s=0,noms=c(1:ncol(Xna))))
    }
    
    #DPMPM
    if("DPMPM" %in%Method[[j]]){
      temps0<-proc.time()
      mdf<-missing_data.frame(Xna, subclass = "allcategorical")
      imp <- mi(mdf, n.chains = m)
      dfs <- mi::complete(imp, m = m)
      x.imp<-lapply(dfs,'[',1:ncol(Xna))
      temps1<-proc.time()
      res.time[2,j,]<-temps1-temps0
    }
    
    #loglinear
    if("da.cat" %in%Method[[j]]){
      temps0<-proc.time()
      datamod<-matrix(NA,nrow(Xna),ncol(Xna))
      for (i in 1:ncol(datamod)){
        datamod[,i]<-as.numeric(Xna[,i])
      }
      s<-prelim.cat(datamod)
      imp <- list()
      #initialisation
      rngseed(7817)
      if(is.null(Theta[[j]])){theta.choose <- em.cat(s,showits=FALSE)  }else{theta.choose<-Theta[[j]]}
      for (i in 1:m) {
        theta.choose <- da.cat(s,theta.choose,steps=1000,showits=FALSE) 
        imp[[i]] <- imp.cat(s,theta.choose)
      } 
      imp<-lapply(imp,FUN=function(x,data){y<-x;colnames(y)<-colnames(data);return(y)},data=Xna)
      temps1<-proc.time()
      res.time[1,j,]<-temps1-temps0
    }
    
    
    #fcs_log
    if("mice_log" %in%Method[[j]]){
      res.time[5,j,]<-system.time(x.imp<-lapply(1:m,mice:::complete,x=mice(Xna,m=m,printFlag=FALSE)))
    }
    
    #fcs_forest
    if("mice_rf" %in%Method[[j]]){
      res.time[6,j,]<-system.time(x.imp<-lapply(1:m,mice:::complete,x=mice(Xna,m=m,printFlag=FALSE,method="rf")))
    }
    
    print(res.time[,,"elapsed"])
    save(res.time,file=paste(path.save,"res.time_pop.Rdata",sep=""))
    
  }
  
  load(paste(path.save,"res.time_pop.Rdata",sep=""))
  res.time[,,"elapsed"]
}
